from comptab import fcomp
from bitcoding import B_dict
from inverse import inv
from collections import deque
from counters import counter
from itertools import combinations
from helpfuncs import bitdecoding
from baserels import B

DALL = B_dict['DALL']

# path consistency using van Beek weights
def bon(ConMatrix, neighbors):
   pq = deque([])                         # list of entries arranged in a heap
   entry_finder = set([])               # mapping of tasks to entries
   Vars = len(ConMatrix)
   bonnes = set()

   def add_task(task):
       'Add a new task or update the priority of an existing task'
       if task not in entry_finder:
          entry_finder.add(task)
          pq.append(task)
          
   def pop_task():
       'Remove and return the lowest priority task. Raise KeyError if empty.'
       task = pq.popleft()
       entry_finder.discard(task)
       return task

   # initialize queue
   map(add_task,[(i,j) for i in xrange(Vars) for j in xrange(i+1,Vars) if ConMatrix[i][j] != DALL])

   # as long as the queue is not empty, process it
   while pq:

      (i,j) = pop_task() # grab the appropriate relation
      
      counter['arcs'] += 1 # increment visited arcs counter 

      P = DALL
  
      # create all triplets to be checked for path consistency
      for k in xrange(Vars):

          temp = fcomp[ConMatrix[i][k]-1][ConMatrix[k][j]-1]
          if temp != DALL and i != k != j:

             P &= temp

      if P != ConMatrix[i][j]:
         bonnes.add((i,j))

   return bonnes         
